--- old/usr/src/uts/common/io/comstar/port/qlt/qlt.c	Mon Aug  5 17:27:33 2019
+++ new/usr/src/uts/common/io/comstar/port/qlt/qlt.c	Mon Aug  5 17:27:33 2019
@@ -2835,13 +4597,33 @@
 fct_status_t
 qlt_read_nvram(qlt_state_t *qlt)
 {
-	uint32_t		index, addr, chksum;
-	uint32_t		val, *ptr;
-	fct_status_t		ret;
-	qlt_nvram_t		*nv;
-	uint64_t		empty_node_name = 0;
+	uint32_t index, addr, chksum;
+	uint32_t val, *ptr;
+	fct_status_t ret;
+	qlt_nvram_t *nv;
+	uint64_t empty_node_name = 0;
 
-	if (qlt->qlt_81xx_chip) {
+	if (qlt->qlt_27xx_chip) {
+		int func;
+
+		func = ((REG_RD32(qlt, REG_CTRL_STATUS) & 0x0000f000) >> 12);
+		switch (func) {
+		case 0: addr = QLT27_NVRAM_FUNC0_ADDR; break;
+		case 1: addr = QLT27_NVRAM_FUNC1_ADDR; break;
+		case 2: addr = QLT27_NVRAM_FUNC2_ADDR; break;
+		case 3: addr = QLT27_NVRAM_FUNC3_ADDR; break;
+		}
+	} else if (qlt->qlt_83xx_chip) {
+		if (qlt->qlt_fcoe_enabled) {
+			addr = REG_RD32(qlt, REG_CTRL_STATUS) & BIT_12 ?
+			    QLT83FCOE_NVRAM_FUNC1_ADDR :
+			    QLT83FCOE_NVRAM_FUNC0_ADDR;
+		} else {
+			addr = REG_RD32(qlt, REG_CTRL_STATUS) & BIT_12 ?
+			    QLT83FC_NVRAM_FUNC1_ADDR :
+			    QLT83FC_NVRAM_FUNC0_ADDR;
+		}
+	} else if (qlt->qlt_81xx_chip) {
 		addr = REG_RD32(qlt, REG_CTRL_STATUS) & BIT_12 ?
 		    QLT81_NVRAM_FUNC1_ADDR : QLT81_NVRAM_FUNC0_ADDR;
 	} else if (qlt->qlt_25xx_chip) {
@@ -2899,6 +4681,227 @@
 	return (QLT_SUCCESS);
 }
 
+fct_status_t
+qlt_read_vpd(qlt_state_t *qlt)
+{
+	uint32_t index, addr, chksum;
+	uint32_t val, *ptr;
+	fct_status_t ret;
+
+	if (qlt->qlt_27xx_chip) {
+		int func;
+
+		func = ((REG_RD32(qlt, REG_CTRL_STATUS) & 0x0000f000) >> 12);
+		switch (func) {
+		case 0: addr = QLT27_VPD_FUNC0_ADDR; break;
+		case 1: addr = QLT27_VPD_FUNC1_ADDR; break;
+		case 2: addr = QLT27_VPD_FUNC2_ADDR; break;
+		case 3: addr = QLT27_VPD_FUNC3_ADDR; break;
+		}
+	} else if (qlt->qlt_83xx_chip) {
+		if (qlt->qlt_fcoe_enabled) {
+			addr = REG_RD32(qlt, REG_CTRL_STATUS) & BIT_12 ?
+			    QLT83FCOE_VPD_FUNC1_ADDR :
+			    QLT83FCOE_VPD_FUNC0_ADDR;
+		} else {
+			addr = REG_RD32(qlt, REG_CTRL_STATUS) & BIT_12 ?
+			    QLT83FC_VPD_FUNC1_ADDR :
+			    QLT83FC_VPD_FUNC0_ADDR;
+		}
+	} else if (qlt->qlt_81xx_chip) {
+		addr = REG_RD32(qlt, REG_CTRL_STATUS) & BIT_12 ?
+		    QLT81_VPD_FUNC1_ADDR : QLT81_VPD_FUNC0_ADDR;
+	} else if (qlt->qlt_25xx_chip) {
+		addr = REG_RD32(qlt, REG_CTRL_STATUS) & FUNCTION_NUMBER ?
+		    QLT25_VPD_FUNC1_ADDR : QLT25_VPD_FUNC0_ADDR;
+	} else {
+		addr = REG_RD32(qlt, REG_CTRL_STATUS) & FUNCTION_NUMBER ?
+		    QLT24_VPD_FUNC1_ADDR : QLT24_VPD_FUNC0_ADDR;
+	}
+	mutex_enter(&qlt_global_lock);
+
+	/* Pause RISC. */
+	REG_WR32(qlt, REG_HCCR, HCCR_CMD(SET_RISC_PAUSE));
+	(void) REG_RD32(qlt, REG_HCCR);	/* PCI Posting. */
+
+	/* Get VPD data and calculate checksum. */
+	ptr = (uint32_t *)qlt->vpd;
+	chksum = 0;
+	for (index = 0; index < QL_24XX_VPD_SIZE / 4; index++) {
+		ret = qlt_read_flash_word(qlt, addr++, &val);
+		if (ret != QLT_SUCCESS) {
+			EL(qlt, "qlt_read_flash_word, status=%llxh\n", ret);
+			mutex_exit(&qlt_global_lock);
+			return (ret);
+		}
+		chksum += val;
+		*ptr = LE_32(val);
+		ptr++;
+	}
+
+	/* Release RISC Pause */
+	REG_WR32(qlt, REG_HCCR, HCCR_CMD(CLEAR_RISC_PAUSE));
+	(void) REG_RD32(qlt, REG_HCCR);	/* PCI Posting. */
+
+	mutex_exit(&qlt_global_lock);
+
+	return (QLT_SUCCESS);
+}
+
+fct_status_t
+qlt_read_bfe(qlt_state_t *qlt, uint32_t in_addr, uint32_t *out_addr, uint32_t i)
+{
+	uint32_t index;
+	uint32_t chksum;
+	fct_status_t ret = QLT_SUCCESS;
+	uint32_t val;
+	uint16_t dataoffset;
+	uint32_t *ptr;
+	uint32_t addr, addr0;
+	uint16_t length;
+
+	val = chksum = 0;
+	ptr = (uint32_t *)&qlt->rimage[i].header;
+
+	addr = in_addr;
+	addr0 = addr;
+
+	/* read rom header first */
+	for (index = 0; index < sizeof (qlt_rom_header_t)/4;
+	    index ++) {
+		ret = qlt_read_flash_word(qlt, addr++, &val);
+		if (ret != QLT_SUCCESS) {
+			EL(qlt, "read flash, status=%llxh\n", ret);
+			return (ret);
+		}
+		chksum += val;
+		*ptr = LE_32(val);
+		ptr++;
+	}
+
+	/* check the signature */
+	if (qlt->rimage[i].header.signature[0] != PCI_HEADER0) {
+		EL(qlt, "hdr[%d] sig[1] [0] (%xh) (%xh) is wrong.\n",
+		    i, qlt->rimage[i].header.signature[1],
+		    qlt->rimage[i].header.signature[0]);
+		return (QLT_SUCCESS);
+	}
+
+	if ((qlt->rimage[i].header.signature[0] == PCI_HEADER0) &&
+	    (qlt->rimage[i].header.signature[1] == PCI_HEADER1)) {
+		/* get dataoffset */
+		dataoffset = (qlt->rimage[i].header.dataoffset[1] |
+		    qlt->rimage[i].header.dataoffset[0]);
+		EL(qlt, "dataoffset[0] = %xh\n", dataoffset);
+
+		ptr = (uint32_t *)&qlt->rimage[i].data;
+
+		/* adjust addr */
+		addr = addr0 + (dataoffset/4);
+		for (index = 0; index < sizeof (qlt_rom_data_t)/4;
+		    index ++) {
+			ret = qlt_read_flash_word(qlt, addr++, &val);
+			if (ret != QLT_SUCCESS) {
+				EL(qlt, "read flash, status=%llxh\n", ret);
+				return (ret);
+			}
+			chksum += val;
+			*ptr = LE_32(val);
+			ptr++;
+		}
+
+		/* check signature */
+		if ((qlt->rimage[i].data.signature[0] != 0x50) &&
+		    (qlt->rimage[i].data.signature[1] != 0x43) &&
+		    (qlt->rimage[i].data.signature[2] != 0x49) &&
+		    (qlt->rimage[i].data.signature[3] != 0x52)) {
+			EL(qlt,
+			    "data sig[3] [2] [1] [0] (%xh)(%xh)(%xh)(%xh)\n",
+			    qlt->rimage[i].data.signature[3],
+			    qlt->rimage[i].data.signature[2],
+			    qlt->rimage[i].data.signature[1],
+			    qlt->rimage[i].data.signature[0]);
+			return (QLT_SUCCESS);
+		}
+
+		EL(qlt, "codetype (%xh) revisionlevel[1][0] (%xh)(%xh)\n",
+		    qlt->rimage[i].data.codetype,
+		    qlt->rimage[i].data.revisionlevel[1],
+		    qlt->rimage[i].data.revisionlevel[0]);
+
+		/* check if this is the last image */
+		if (qlt->rimage[i].data.indicator == PCI_IND_LAST_IMAGE) {
+			EL(qlt, "last image (%xh)\n",
+			    qlt->rimage[i].data.indicator);
+			return (QLT_SUCCESS);
+
+		}
+
+		/* Get the image length and adjust the addr according */
+		length = (qlt->rimage[i].data.imagelength[1] |
+		    qlt->rimage[i].data.imagelength[0]);
+
+		EL(qlt, "image[%d] length[1][0] (%xh) (%xh) in sectors\n",
+		    i, length);
+
+		/* the starting addr of the next image */
+		addr = addr0 + ((length * 512)/4);
+		*out_addr = addr;
+	}
+
+	return (QLT_SUCCESS);
+}
+
+fct_status_t
+qlt_read_rom_image(qlt_state_t *qlt)
+{
+	uint32_t addr;
+	uint32_t out_addr = 0;
+	uint32_t count = 0;
+	boolean_t last_image = FALSE;
+	fct_status_t ret;
+
+	if (qlt->qlt_27xx_chip) {
+		addr = FLASH_2700_DATA_ADDR + FLASH_2700_BOOT_CODE_ADDR;
+	} else if (qlt->qlt_83xx_chip) {
+		addr = FLASH_8300_DATA_ADDR + FLASH_8300_BOOT_CODE_ADDR;
+	} else if (qlt->qlt_81xx_chip) {
+		addr = FLASH_8100_DATA_ADDR + FLASH_8100_BOOT_CODE_ADDR;
+	} else if (qlt->qlt_25xx_chip) {
+		addr = FLASH_2500_DATA_ADDR + FLASH_2500_BOOT_CODE_ADDR;
+	} else {
+		addr = FLASH_2400_DATA_ADDR + FLASH_2400_BOOT_CODE_ADDR;
+	}
+	mutex_enter(&qlt_global_lock);
+
+	/* Pause RISC. */
+	REG_WR32(qlt, REG_HCCR, HCCR_CMD(SET_RISC_PAUSE));
+	(void) REG_RD32(qlt, REG_HCCR);	/* PCI Posting. */
+
+	do {
+		ret = qlt_read_bfe(qlt, addr, &out_addr, count);
+		if (ret != QLT_SUCCESS) {
+			EL(qlt, "qlt_read_bfe, status=%llxh\n", ret);
+			break;
+		}
+		if (qlt->rimage[count].data.indicator ==
+		    PCI_IND_LAST_IMAGE) {
+			last_image = TRUE;
+		} else {
+			addr = out_addr;
+		}
+		count ++;
+	} while ((last_image != TRUE) && (count < 6));
+
+	/* Release RISC Pause */
+	REG_WR32(qlt, REG_HCCR, HCCR_CMD(CLEAR_RISC_PAUSE));
+	(void) REG_RD32(qlt, REG_HCCR);	/* PCI Posting. */
+
+	mutex_exit(&qlt_global_lock);
+
+	return (QLT_SUCCESS);
+}
+
 uint32_t
 qlt_sync_atio_queue(qlt_state_t *qlt)
 {
@@ -2942,12 +4945,12 @@
 			break;
 		}
 		switch ((uint8_t)(atio[0])) {
+		case 0x06:	/* ATIO, make performance case the 1st test */
+			qlt_handle_atio(qlt, atio);
+			break;
 		case 0x0d:	/* INOT */
 			qlt_handle_inot(qlt, atio);
 			break;
-		case 0x06:	/* ATIO */
-			qlt_handle_atio(qlt, atio);
-			break;
 		default:
 			EL(qlt, "atio_queue_update atio[0]=%xh\n", atio[0]);
 			cmn_err(CE_WARN, "qlt_handle_atio_queue_update: "
@@ -2958,47 +4961,86 @@
 		    (qlt->atio_ndx_to_fw + ent_cnt) & (ATIO_QUEUE_ENTRIES - 1));
 		total_ent -= ent_cnt;
 	} while (total_ent > 0);
-	REG_WR32(qlt, REG_ATIO_OUT_PTR, qlt->atio_ndx_to_fw);
+
+	if ((qlt->qlt_83xx_chip) || (qlt->qlt_27xx_chip)) {
+		MQBAR_WR32(qlt, MQBAR_ATIO_OUT, qlt->atio_ndx_to_fw);
+	} else {
+		REG_WR32(qlt, REG_ATIO_OUT_PTR, qlt->atio_ndx_to_fw);
+	}
 }
 
 uint32_t
-qlt_sync_resp_queue(qlt_state_t *qlt)
+qlt_sync_resp_queue(qlt_state_t *qlt, uint16_t qi)
 {
 	uint32_t total_ent;
 
-	if (qlt->resp_ndx_from_fw > qlt->resp_ndx_to_fw) {
-		total_ent = qlt->resp_ndx_from_fw - qlt->resp_ndx_to_fw;
-		(void) ddi_dma_sync(qlt->queue_mem_dma_handle,
-		    RESPONSE_QUEUE_OFFSET
-		    + (qlt->resp_ndx_to_fw << 6), total_ent << 6,
-		    DDI_DMA_SYNC_FORCPU);
+	if (qlt->mq_resp[qi].mq_ndx_from_fw > qlt->mq_resp[qi].mq_ndx_to_fw) {
+		total_ent = qlt->mq_resp[qi].mq_ndx_from_fw -
+		    qlt->mq_resp[qi].mq_ndx_to_fw;
+		if (qi) {
+			(void) ddi_dma_sync(
+			    qlt->mq_resp[qi].queue_mem_mq_dma_handle,
+			    (qlt->mq_resp[qi].mq_ndx_to_fw << 6),
+			    total_ent << 6,
+			    DDI_DMA_SYNC_FORCPU);
+		} else {
+			(void) ddi_dma_sync(
+			    qlt->queue_mem_dma_handle,
+			    RESPONSE_QUEUE_OFFSET +
+			    (qlt->mq_resp[qi].mq_ndx_to_fw << 6),
+			    total_ent << 6,
+			    DDI_DMA_SYNC_FORCPU);
+		}
 	} else {
-		total_ent = RESPONSE_QUEUE_ENTRIES - qlt->resp_ndx_to_fw +
-		    qlt->resp_ndx_from_fw;
-		(void) ddi_dma_sync(qlt->queue_mem_dma_handle,
-		    RESPONSE_QUEUE_OFFSET
-		    + (qlt->resp_ndx_to_fw << 6), (RESPONSE_QUEUE_ENTRIES -
-		    qlt->resp_ndx_to_fw) << 6, DDI_DMA_SYNC_FORCPU);
-		(void) ddi_dma_sync(qlt->queue_mem_dma_handle,
-		    RESPONSE_QUEUE_OFFSET,
-		    qlt->resp_ndx_from_fw << 6, DDI_DMA_SYNC_FORCPU);
+		total_ent =
+		    (qi ? RESPONSE_QUEUE_MQ_ENTRIES : RESPONSE_QUEUE_ENTRIES) -
+		    qlt->mq_resp[qi].mq_ndx_to_fw +
+		    qlt->mq_resp[qi].mq_ndx_from_fw;
+
+		if (qi) {
+
+			(void) ddi_dma_sync(
+			    qlt->mq_resp[qi].queue_mem_mq_dma_handle,
+			    qlt->mq_resp[qi].mq_ndx_to_fw << 6,
+			    (RESPONSE_QUEUE_MQ_ENTRIES -
+			    qlt->mq_resp[qi].mq_ndx_to_fw) << 6,
+			    DDI_DMA_SYNC_FORCPU);
+			(void) ddi_dma_sync(
+			    qlt->mq_resp[qi].queue_mem_mq_dma_handle, 0,
+			    qlt->mq_resp[qi].mq_ndx_from_fw << 6,
+			    DDI_DMA_SYNC_FORCPU);
+		} else {
+			(void) ddi_dma_sync(qlt->queue_mem_dma_handle,
+			    RESPONSE_QUEUE_OFFSET +
+			    (qlt->mq_resp[qi].mq_ndx_to_fw << 6),
+			    (RESPONSE_QUEUE_ENTRIES -
+			    qlt->mq_resp[qi].mq_ndx_to_fw) << 6,
+			    DDI_DMA_SYNC_FORCPU);
+			(void) ddi_dma_sync(qlt->queue_mem_dma_handle,
+			    RESPONSE_QUEUE_OFFSET,
+			    qlt->mq_resp[qi].mq_ndx_from_fw << 6,
+			    DDI_DMA_SYNC_FORCPU);
+		}
 	}
+
 	return (total_ent);
 }
 
 void
-qlt_handle_resp_queue_update(qlt_state_t *qlt)
+qlt_handle_resp_queue_update(qlt_state_t *qlt, uint16_t qi)
 {
 	uint32_t total_ent;
 	uint8_t c;
 
-	if (qlt->resp_ndx_to_fw == qlt->resp_ndx_from_fw)
+	if (qlt->mq_resp[qi].mq_ndx_to_fw == qlt->mq_resp[qi].mq_ndx_from_fw)
 		return;
 
-	total_ent = qlt_sync_resp_queue(qlt);
+	total_ent = qlt_sync_resp_queue(qlt, qi);
 
 	do {
-		caddr_t resp = &qlt->resp_ptr[qlt->resp_ndx_to_fw << 6];
+		uint32_t qe = qlt->mq_resp[qi].mq_ndx_to_fw;
+		caddr_t resp = &qlt->mq_resp[qi].mq_ptr[qe << 6];
+
 		uint32_t ent_cnt;
 
 		ent_cnt = (uint32_t)(resp[0] == 0x51 ? resp[1] : 1);
@@ -3007,7 +5049,7 @@
 		}
 		switch ((uint8_t)(resp[0])) {
 		case 0x12:	/* CTIO completion */
-			qlt_handle_ctio_completion(qlt, (uint8_t *)resp);
+			qlt_handle_ctio_completion(qlt, (uint8_t *)resp, qi);
 			break;
 		case 0x0e:	/* NACK */
 			/* Do Nothing */
@@ -3018,6 +5060,9 @@
 		case 0x29:	/* CT PassThrough */
 			qlt_handle_ct_completion(qlt, (uint8_t *)resp);
 			break;
+		case 0x32:	/* Report ID */
+			EL(qlt, "report Id received [type %xh]\n", resp[0]);
+			break;
 		case 0x33:	/* Abort IO IOCB completion */
 			qlt_handle_sol_abort_completion(qlt, (uint8_t *)resp);
 			break;
@@ -3041,25 +5086,37 @@
 			}
 			break;
 		case 0x54:	/* ABTS received */
-			qlt_handle_rcvd_abts(qlt, (uint8_t *)resp);
+			qlt_handle_rcvd_abts(qlt, (uint8_t *)resp, qi);
 			break;
 		case 0x55:	/* ABTS completion */
-			qlt_handle_abts_completion(qlt, (uint8_t *)resp);
+			qlt_handle_abts_completion(qlt, (uint8_t *)resp, qi);
 			break;
 		default:
 			EL(qlt, "response entry=%xh\n", resp[0]);
 			break;
 		}
-		qlt->resp_ndx_to_fw = (qlt->resp_ndx_to_fw + ent_cnt) &
-		    (RESPONSE_QUEUE_ENTRIES - 1);
+		if (qi != 0) {
+			qlt->mq_resp[qi].mq_ndx_to_fw =
+			    (qlt->mq_resp[qi].mq_ndx_to_fw + ent_cnt) &
+			    (RESPONSE_QUEUE_MQ_ENTRIES - 1);
+		} else {
+			qlt->mq_resp[qi].mq_ndx_to_fw =
+			    (qlt->mq_resp[qi].mq_ndx_to_fw + ent_cnt) &
+			    (RESPONSE_QUEUE_ENTRIES - 1);
+		}
 		total_ent -= ent_cnt;
 	} while (total_ent > 0);
-	REG_WR32(qlt, REG_RESP_OUT_PTR, qlt->resp_ndx_to_fw);
+	if (qlt->qlt_mq_enabled) {
+		MQBAR_WR32(qlt, (qi * MQBAR_REG_OFFSET) + MQBAR_RESP_OUT,
+		    qlt->mq_resp[qi].mq_ndx_to_fw);
+	} else {
+		REG_WR32(qlt, REG_RESP_OUT_PTR, qlt->mq_resp[qi].mq_ndx_to_fw);
+	}
 }
 
 fct_status_t
 qlt_portid_to_handle(qlt_state_t *qlt, uint32_t id, uint16_t cmd_handle,
-				uint16_t *ret_handle)
+    uint16_t *ret_handle)
 {
 	fct_status_t ret;
 	mbox_cmd_t *mcp;
@@ -3081,13 +5138,17 @@
 
 	ret = qlt_mailbox_command(qlt, mcp);
 	if (ret != QLT_SUCCESS) {
-		EL(qlt, "qlt_mailbox_command=7Ch status=%llxh\n", ret);
-		cmn_err(CE_WARN, "GET ID list failed, ret = %llx, mb0=%x, "
-		    "mb1=%x, mb2=%x", (long long)ret, mcp->from_fw[0],
-		    mcp->from_fw[1], mcp->from_fw[2]);
+		EL(qlt, "qlt_mbox_command=7Ch status=%llxh\n", ret);
+		cmn_err(CE_WARN, "qlt(%d) GET ID list failed, ret = %llx, "
+		    "mb0=%x, mb1=%x, mb2=%x", qlt->instance, (long long)ret,
+		    mcp->from_fw[0], mcp->from_fw[1], mcp->from_fw[2]);
 		qlt_free_mailbox_command(qlt, mcp);
 		return (ret);
 	}
+
+	EL(qlt, "mbx cmd=7Ch, GET_ID_LIST id=%x fw[1]=%x\n",
+	    id, mcp->from_fw[1]);
+
 	qlt_dmem_dma_sync(mcp->dbuf, DDI_DMA_SYNC_FORCPU);
 	p = mcp->dbuf->db_sglist[0].seg_addr;
 	for (n = 0; n < mcp->from_fw[1]; n++) {
@@ -3098,10 +5159,10 @@
 			*ret_handle = h;
 			if ((cmd_handle != FCT_HANDLE_NONE) &&
 			    (cmd_handle != h)) {
-				cmn_err(CE_WARN, "login for portid %x came in "
-				    "with handle %x, while the portid was "
-				    "already using a different handle %x",
-				    id, cmd_handle, h);
+				cmn_err(CE_WARN, "qlt(%d) login for portid %x "
+				    "came in with handle %x, while the portid "
+				    "was already using a different handle %x",
+				    qlt->instance, id, cmd_handle, h);
 				qlt_free_mailbox_command(qlt, mcp);
 				return (QLT_FAILURE);
 			}
@@ -3108,9 +5169,10 @@
 			break;
 		}
 		if ((cmd_handle != FCT_HANDLE_NONE) && (h == cmd_handle)) {
-			cmn_err(CE_WARN, "login for portid %x came in with "
-			    "handle %x, while the handle was already in use "
-			    "for portid %x", id, cmd_handle, ent_id);
+			cmn_err(CE_WARN, "qlt(%d) login for portid %x came in "
+			    "with handle %x, while the handle was already in "
+			    "use for portid %x",
+			    qlt->instance, id, cmd_handle, ent_id);
 			qlt_free_mailbox_command(qlt, mcp);
 			return (QLT_FAILURE);
 		}
@@ -3126,7 +5188,7 @@
 /* ARGSUSED */
 fct_status_t
 qlt_fill_plogi_req(fct_local_port_t *port, fct_remote_port_t *rp,
-				fct_cmd_t *login)
+    fct_cmd_t *login)
 {
 	uint8_t *p;
 
@@ -3153,7 +5215,7 @@
 /* ARGSUSED */
 fct_status_t
 qlt_fill_plogi_resp(fct_local_port_t *port, fct_remote_port_t *rp,
-				fct_cmd_t *login)
+    fct_cmd_t *login)
 {
 	return (FCT_SUCCESS);
 }
@@ -3191,6 +5253,9 @@
 		return (ret);
 	}
 
+	EL(qlt, "rport id=%xh cmd_type=%xh handle=%xh(%xh)\n",
+	    rp->rp_id, login->cmd_type, h, rp->rp_handle);
+
 	if (h == FCT_HANDLE_NONE)
 		return (FCT_SUCCESS);
 
@@ -3202,9 +5267,10 @@
 	if (rp->rp_handle == h)
 		return (FCT_SUCCESS);
 
-	EL(qlt, "rp_handle=%xh != h=%xh\n", rp->rp_handle, h);
+	EL(qlt, "failed, rp_handle=%xh != h=%xh\n", rp->rp_handle, h);
 	return (FCT_FAILURE);
 }
+
 /* invoked in single thread */
 fct_status_t
 qlt_deregister_remote_port(fct_local_port_t *port, fct_remote_port_t *rp)
@@ -3221,11 +5287,22 @@
 		return (FCT_SUCCESS);
 	ASSERT(qlt->rp_id_in_dereg == 0);
 
-	mutex_enter(&qlt->preq_lock);
-	req = (uint8_t *)qlt_get_preq_entries(qlt, 1);
-	if (req == NULL) {
-		mutex_exit(&qlt->preq_lock);
-		return (FCT_BUSY);
+	if ((qlt->qlt_83xx_chip) || (qlt->qlt_27xx_chip)) {
+		mutex_enter(&qlt->mq_req[0].mq_lock);
+		req = (uint8_t *)qlt_get_req_entries(qlt, 1, 0);
+		if (req == NULL) {
+			EL(qlt, "req = NULL\n");
+			mutex_exit(&qlt->mq_req[0].mq_lock);
+			return (FCT_BUSY);
+		}
+	} else {
+		mutex_enter(&qlt->preq_lock);
+		req = (uint8_t *)qlt_get_preq_entries(qlt, 1);
+		if (req == NULL) {
+			EL(qlt, "req = NULL\n");
+			mutex_exit(&qlt->preq_lock);
+			return (FCT_BUSY);
+		}
 	}
 	bzero(req, IOCB_SIZE);
 	req[0] = 0x52; req[1] = 1;
@@ -3234,11 +5311,17 @@
 	QMEM_WR16(qlt, (&req[0xC]), 0x98); /* implicit logo */
 	QMEM_WR32(qlt, (&req[0x10]), rp->rp_id);
 	qlt->rp_id_in_dereg = rp->rp_id;
-	qlt_submit_preq_entries(qlt, 1);
+	if ((qlt->qlt_83xx_chip) || (qlt->qlt_27xx_chip)) {
+		qlt_submit_req_entries(qlt, 1, 0);
+	} else {
+		qlt_submit_preq_entries(qlt, 1);
+	}
 
 	dereg_req_timer = ddi_get_lbolt() + drv_usectohz(DEREG_RP_TIMEOUT);
 	if (cv_timedwait(&qlt->rp_dereg_cv,
-	    &qlt->preq_lock, dereg_req_timer) > 0) {
+	    (((qlt->qlt_83xx_chip) || (qlt->qlt_27xx_chip)) ?
+	    &qlt->mq_req[0].mq_lock : &qlt->preq_lock),
+	    dereg_req_timer) > 0) {
 		ret = qlt->rp_dereg_status;
 	} else {
 		ret = FCT_BUSY;
@@ -3245,7 +5328,15 @@
 	}
 	qlt->rp_dereg_status = 0;
 	qlt->rp_id_in_dereg = 0;
-	mutex_exit(&qlt->preq_lock);
+	if ((qlt->qlt_83xx_chip) || (qlt->qlt_27xx_chip)) {
+		mutex_exit(&qlt->mq_req[0].mq_lock);
+	} else {
+		mutex_exit(&qlt->preq_lock);
+	}
+
+	EL(qlt, "Dereg remote port(%Xh), ret=%llxh\n",
+	    rp->rp_id, ret);
+
 	return (ret);
 }
 
@@ -3263,7 +5354,7 @@
 	uint8_t			*pldptr, *bndrptr;
 	int			i, off;
 	uint16_t		iocb_flags;
-	char			info[QLT_INFO_LEN];
+	char			info[160];
 
 	remote_portid = ((uint32_t)(QMEM_RD16(qlt, (&resp[0x18])))) |
 	    ((uint32_t)(resp[0x1A])) << 16;
@@ -3285,9 +5376,9 @@
 	if (cmd == NULL) {
 		EL(qlt, "fct_alloc cmd==NULL\n");
 cmd_null:;
-		(void) snprintf(info, sizeof (info),
-		    "qlt_handle_purex: qlt-%p, "
-		    "can't allocate space for fct_cmd", (void *)qlt);
+		(void) snprintf(info, 160, "qlt_handle_purex: qlt-%p, can't "
+		    "allocate space for fct_cmd", (void *)qlt);
+		info[159] = 0;
 		(void) fct_port_shutdown(qlt->qlt_port,
 		    STMF_RFLAG_FATAL_ERROR | STMF_RFLAG_RESET, info);
 		return;
@@ -3311,7 +5402,8 @@
 	cmd->cmd_oxid = QMEM_RD16(qlt, (&resp[0x26]));
 	cmd->cmd_rxid = QMEM_RD16(qlt, (&resp[0x24]));
 	pldptr = &resp[0x2C];
-	bndrptr = (uint8_t *)(qlt->resp_ptr + (RESPONSE_QUEUE_ENTRIES << 6));
+	bndrptr = (uint8_t *)(qlt->mq_resp[0].mq_ptr
+	    + (RESPONSE_QUEUE_ENTRIES << 6));
 	for (i = 0, off = 0x2c; i < payload_size; i += 4) {
 		/* Take care of fw's swapping of payload */
 		els->els_req_payload[i] = pldptr[3];
@@ -3320,7 +5412,7 @@
 		els->els_req_payload[i+3] = pldptr[0];
 		pldptr += 4;
 		if (pldptr == bndrptr)
-			pldptr = (uint8_t *)qlt->resp_ptr;
+			pldptr = (uint8_t *)qlt->mq_resp[0].mq_ptr;
 		off += 4;
 		if (off >= IOCB_SIZE) {
 			off = 4;
@@ -3327,6 +5419,10 @@
 			pldptr += 4;
 		}
 	}
+
+	EL(qlt, "remote portid = %xh logi/o(%xh) to us revd rex1=%xh\n",
+	    remote_portid, els->els_req_payload[0], qcmd->fw_xchg_addr);
+
 	fct_post_rcvd_cmd(cmd, 0);
 }
 
@@ -3334,7 +5430,7 @@
 qlt_send_cmd_response(fct_cmd_t *cmd, uint32_t ioflags)
 {
 	qlt_state_t	*qlt;
-	char		info[QLT_INFO_LEN];
+	char		info[160];
 
 	qlt = (qlt_state_t *)cmd->cmd_port->port_fca_private;
 
@@ -3368,10 +5464,10 @@
 	}
 
 fatal_panic:;
-	(void) snprintf(info, sizeof (info),
-	    "qlt_send_cmd_response: can not handle "
+	(void) snprintf(info, 160, "qlt_send_cmd_response: can not handle "
 	    "FCT_IOF_FORCE_FCA_DONE for cmd %p, ioflags-%x", (void *)cmd,
 	    ioflags);
+	info[159] = 0;
 	(void) fct_port_shutdown(qlt->qlt_port,
 	    STMF_RFLAG_FATAL_ERROR | STMF_RFLAG_RESET, info);
 	return (FCT_FAILURE);
@@ -3381,13 +5477,17 @@
 fct_status_t
 qlt_xfer_scsi_data(fct_cmd_t *cmd, stmf_data_buf_t *dbuf, uint32_t ioflags)
 {
-	qlt_dmem_bctl_t	*bctl = (qlt_dmem_bctl_t *)dbuf->db_port_private;
-	qlt_state_t	*qlt = (qlt_state_t *)cmd->cmd_port->port_fca_private;
-	qlt_cmd_t	*qcmd = (qlt_cmd_t *)cmd->cmd_fca_private;
-	uint8_t		*req, rcnt;
-	uint16_t	flags;
-	uint16_t	cookie_count;
+	qlt_dmem_bctl_t *bctl = (qlt_dmem_bctl_t *)dbuf->db_port_private;
+	qlt_state_t *qlt = (qlt_state_t *)cmd->cmd_port->port_fca_private;
+	qlt_cmd_t *qcmd = (qlt_cmd_t *)cmd->cmd_fca_private;
+	uint8_t *req, rcnt;
+	uint16_t flags;
+	uint16_t cookie_count;
+	uint32_t ent_cnt;
+	uint16_t qi;
 
+	qi = qcmd->qid;
+
 	if (dbuf->db_handle == 0)
 		qcmd->dbuf = dbuf;
 	flags = (uint16_t)(((uint16_t)qcmd->param.atio_byte3 & 0xf0) << 5);
@@ -3411,26 +5511,26 @@
 		cookie_count = 1;
 		rcnt = 1;
 	}
-	mutex_enter(&qlt->req_lock);
-	req = (uint8_t *)qlt_get_req_entries(qlt, rcnt);
+	mutex_enter(&qlt->mq_req[qi].mq_lock);
+	req = (uint8_t *)qlt_get_req_entries(qlt, 1, qi);
 	if (req == NULL) {
-		mutex_exit(&qlt->req_lock);
+		mutex_exit(&qlt->mq_req[qi].mq_lock);
 		return (FCT_BUSY);
 	}
-	bzero(req, IOCB_SIZE);	/* XXX needed ? */
+	bzero(req, IOCB_SIZE);
 	req[0] = 0x12;
 	req[1] = rcnt;
 	req[2] = dbuf->db_handle;
-	QMEM_WR32(qlt, req+4, cmd->cmd_handle);
-	QMEM_WR16(qlt, req+8, cmd->cmd_rp->rp_handle);
-	QMEM_WR16(qlt, req+10, 60);	/* 60 seconds timeout */
-	QMEM_WR16(qlt, req+12, cookie_count);
-	QMEM_WR32(qlt, req+0x10, cmd->cmd_rportid);
-	QMEM_WR32(qlt, req+0x14, qcmd->fw_xchg_addr);
-	QMEM_WR16(qlt, req+0x1A, flags);
-	QMEM_WR16(qlt, req+0x20, cmd->cmd_oxid);
-	QMEM_WR32(qlt, req+0x24, dbuf->db_relative_offset);
-	QMEM_WR32(qlt, req+0x2C, dbuf->db_data_size);
+	QMEM_WR32_REQ(qlt, qi, req+4, cmd->cmd_handle);
+	QMEM_WR16_REQ(qlt, qi, req+8, cmd->cmd_rp->rp_handle);
+	QMEM_WR16_REQ(qlt, qi, req+10, 60);	/* 60 seconds timeout */
+	QMEM_WR16_REQ(qlt, qi, req+12, cookie_count);
+	QMEM_WR32_REQ(qlt, qi, req+0x10, cmd->cmd_rportid);
+	QMEM_WR32_REQ(qlt, qi, req+0x14, qcmd->fw_xchg_addr);
+	QMEM_WR16_REQ(qlt, qi, req+0x1A, flags);
+	QMEM_WR16_REQ(qlt, qi, req+0x20, cmd->cmd_oxid);
+	QMEM_WR32_REQ(qlt, qi, req+0x24, dbuf->db_relative_offset);
+	QMEM_WR32_REQ(qlt, qi, req+0x2C, dbuf->db_data_size);
 	if (dbuf->db_flags & DB_LU_DATA_BUF) {
 		uint8_t			*qptr;	/* qlt continuation segs */
 		uint16_t		cookie_resid;
@@ -3447,24 +5547,28 @@
 		 */
 		if (ckp) {
 			ASSERT(ckp->dmac_size);
-			QMEM_WR64(qlt, req+0x34, ckp->dmac_laddress);
-			QMEM_WR32(qlt, req+0x3c, ckp->dmac_size);
+			QMEM_WR64_REQ(qlt, qi, req+0x34, ckp->dmac_laddress);
+			QMEM_WR32_REQ(qlt, qi, req+0x3c, ckp->dmac_size);
 		} else {
 			qlt_ddi_dma_nextcookie(dbuf, &cookie);
 			ASSERT(cookie.dmac_size);
-			QMEM_WR64(qlt, req+0x34, cookie.dmac_laddress);
-			QMEM_WR32(qlt, req+0x3c, cookie.dmac_size);
+			QMEM_WR64_REQ(qlt, qi, req+0x34, cookie.dmac_laddress);
+			QMEM_WR32_REQ(qlt, qi, req+0x3c, cookie.dmac_size);
 		}
 		cookie_resid = cookie_count-1;
 
+		ent_cnt = (qi == 0) ? REQUEST_QUEUE_ENTRIES :
+		    REQUEST_QUEUE_MQ_ENTRIES;
 		/*
 		 * Program remaining segments into continuation records.
 		 */
 		while (cookie_resid) {
 			req += IOCB_SIZE;
-			if (req >= (uint8_t *)qlt->resp_ptr) {
-				req = (uint8_t *)qlt->req_ptr;
+			if (req >= (uint8_t *)(qlt->mq_req[qi].mq_ptr +
+			    (ent_cnt * IOCB_SIZE))) {
+				req = (uint8_t *)(qlt->mq_req[qi].mq_ptr);
 			}
+
 			req[0] = 0x0a;
 			req[1] = 1;
 			req[2] = req[3] = 0;	/* tidy */
@@ -3475,18 +5579,20 @@
 				if (ckp) {
 					++ckp;		/* next cookie */
 					ASSERT(ckp->dmac_size != 0);
-					QMEM_WR64(qlt, qptr,
+					QMEM_WR64_REQ(qlt, qi, qptr,
 					    ckp->dmac_laddress);
 					qptr += 8;	/* skip over laddress */
-					QMEM_WR32(qlt, qptr, ckp->dmac_size);
+					QMEM_WR32_REQ(qlt, qi, qptr,
+					    ckp->dmac_size);
 					qptr += 4;	/* skip over size */
 				} else {
 					qlt_ddi_dma_nextcookie(dbuf, &cookie);
 					ASSERT(cookie.dmac_size != 0);
-					QMEM_WR64(qlt, qptr,
+					QMEM_WR64_REQ(qlt, qi, qptr,
 					    cookie.dmac_laddress);
 					qptr += 8;	/* skip over laddress */
-					QMEM_WR32(qlt, qptr, cookie.dmac_size);
+					QMEM_WR32_REQ(qlt, qi, qptr,
+					    cookie.dmac_size);
 					qptr += 4;	/* skip over size */
 				}
 				cookie_resid--;
@@ -3504,12 +5610,12 @@
 		}
 	} else {
 		/* Single, contiguous buffer */
-		QMEM_WR64(qlt, req+0x34, bctl->bctl_dev_addr);
-		QMEM_WR32(qlt, req+0x34+8, dbuf->db_data_size);
+		QMEM_WR64_REQ(qlt, qi, req+0x34, bctl->bctl_dev_addr);
+		QMEM_WR32_REQ(qlt, qi, req+0x34+8, dbuf->db_data_size);
 	}
 
-	qlt_submit_req_entries(qlt, rcnt);
-	mutex_exit(&qlt->req_lock);
+	qlt_submit_req_entries(qlt, rcnt, qi);
+	mutex_exit(&qlt->mq_req[qi].mq_lock);
 
 	return (STMF_SUCCESS);
 }
@@ -3517,7 +5623,7 @@
 /*
  * We must construct proper FCP_RSP_IU now. Here we only focus on
  * the handling of FCP_SNS_INFO. If there's protocol failures (FCP_RSP_INFO),
- * we could have catched them before we enter here.
+ * we could have caught them before we enter here.
  */
 fct_status_t
 qlt_send_status(qlt_state_t *qlt, fct_cmd_t *cmd)
@@ -3532,7 +5638,10 @@
 	uint16_t scsi_status;
 	int use_mode2;
 	int ndx;
+	uint16_t qi;
 
+	qi = qcmd->qid;
+
 	/*
 	 * Enter fast channel for non check condition
 	 */
@@ -3544,9 +5653,9 @@
 		    (((uint16_t)qcmd->param.atio_byte3 & 0xf0) << 5));
 		scsi_status = (uint16_t)task->task_scsi_status;
 		if (task->task_status_ctrl == TASK_SCTRL_OVER) {
-			scsi_status = (uint16_t)(scsi_status | BIT_10);
+			scsi_status = (uint16_t)(scsi_status | FCP_RESID_OVER);
 		} else if (task->task_status_ctrl == TASK_SCTRL_UNDER) {
-			scsi_status = (uint16_t)(scsi_status | BIT_11);
+			scsi_status = (uint16_t)(scsi_status | FCP_RESID_UNDER);
 		}
 		qcmd->dbuf_rsp_iu = NULL;
 
@@ -3553,10 +5662,10 @@
 		/*
 		 * Fillout CTIO type 7 IOCB
 		 */
-		mutex_enter(&qlt->req_lock);
-		req = (uint8_t *)qlt_get_req_entries(qlt, 1);
+		mutex_enter(&qlt->mq_req[qi].mq_lock);
+		req = (uint8_t *)qlt_get_req_entries(qlt, 1, qi);
 		if (req == NULL) {
-			mutex_exit(&qlt->req_lock);
+			mutex_exit(&qlt->mq_req[qi].mq_lock);
 			return (FCT_BUSY);
 		}
 
@@ -3567,24 +5676,33 @@
 		req[0x00] = 0x12;
 		req[0x01] = 0x1;
 		req[0x02] = BIT_7;	/* indicate if it's a pure status req */
-		QMEM_WR32(qlt, req + 0x04, cmd->cmd_handle);
-		QMEM_WR16(qlt, req + 0x08, cmd->cmd_rp->rp_handle);
-		QMEM_WR32(qlt, req + 0x10, cmd->cmd_rportid);
-		QMEM_WR32(qlt, req + 0x14, qcmd->fw_xchg_addr);
+		QMEM_WR32_REQ(qlt, qi, req + 0x04, cmd->cmd_handle);
+		QMEM_WR16_REQ(qlt, qi, req + 0x08, cmd->cmd_rp->rp_handle);
+		QMEM_WR32_REQ(qlt, qi, req + 0x10, cmd->cmd_rportid);
+		QMEM_WR32_REQ(qlt, qi, req + 0x14, qcmd->fw_xchg_addr);
 
+		/* handle TMF completion - !!! Important FIX */
+		if (task->task_mgmt_function) {
+			scsi_status =
+			    (uint16_t)(scsi_status | FCP_RESP_LEN_VALID);
+
+			/* no sense length, 4 bytes of resp info */
+			QMEM_WR16_REQ(qlt, qi, req + 0x24, 4);
+		}
+
 		/*
 		 * Mode-specific fields
 		 */
-		QMEM_WR16(qlt, req + 0x1A, flags);
-		QMEM_WR32(qlt, req + 0x1C, task->task_resid);
-		QMEM_WR16(qlt, req + 0x20, cmd->cmd_oxid);
-		QMEM_WR16(qlt, req + 0x22, scsi_status);
+		QMEM_WR16_REQ(qlt, qi, req + 0x1A, flags);
+		QMEM_WR32_REQ(qlt, qi, req + 0x1C, task->task_resid);
+		QMEM_WR16_REQ(qlt, qi, req + 0x20, cmd->cmd_oxid);
+		QMEM_WR16_REQ(qlt, qi, req + 0x22, scsi_status);
 
 		/*
 		 * Trigger FW to send SCSI status out
 		 */
-		qlt_submit_req_entries(qlt, 1);
-		mutex_exit(&qlt->req_lock);
+		qlt_submit_req_entries(qlt, 1, qi);
+		mutex_exit(&qlt->mq_req[qi].mq_lock);
 		return (STMF_SUCCESS);
 	}
 
@@ -3681,10 +5799,10 @@
 	/*
 	 * Fillout CTIO type 7 IOCB
 	 */
-	mutex_enter(&qlt->req_lock);
-	req = (uint8_t *)qlt_get_req_entries(qlt, 1);
+	mutex_enter(&qlt->mq_req[qi].mq_lock);
+	req = (uint8_t *)qlt_get_req_entries(qlt, 1, qi);
 	if (req == NULL) {
-		mutex_exit(&qlt->req_lock);
+		mutex_exit(&qlt->mq_req[qi].mq_lock);
 		if (use_mode2) {
 			qlt_dmem_free(cmd->cmd_port->port_fds,
 			    qcmd->dbuf_rsp_iu);
@@ -3700,31 +5818,34 @@
 	req[0x00] = 0x12;
 	req[0x01] = 0x1;
 	req[0x02] = BIT_7;	/* to indicate if it's a pure status req */
-	QMEM_WR32(qlt, req + 0x04, cmd->cmd_handle);
-	QMEM_WR16(qlt, req + 0x08, cmd->cmd_rp->rp_handle);
-	QMEM_WR16(qlt, req + 0x0A, 0);	/* not timed by FW */
+	QMEM_WR32_REQ(qlt, qi, req + 0x04, cmd->cmd_handle);
+	QMEM_WR16_REQ(qlt, qi, req + 0x08, cmd->cmd_rp->rp_handle);
+	QMEM_WR16_REQ(qlt, qi, req + 0x0A, 0);	/* not timed by FW */
 	if (use_mode2) {
-		QMEM_WR16(qlt, req+0x0C, 1);	/* FCP RSP IU data field */
+		/* FCP RSP IU data field */
+		QMEM_WR16_REQ(qlt, qi, req+0x0C, 1);
 	}
-	QMEM_WR32(qlt, req + 0x10, cmd->cmd_rportid);
-	QMEM_WR32(qlt, req + 0x14, qcmd->fw_xchg_addr);
+	QMEM_WR32_REQ(qlt, qi, req + 0x10, cmd->cmd_rportid);
+	QMEM_WR32_REQ(qlt, qi, req + 0x14, qcmd->fw_xchg_addr);
 
 	/*
 	 * Mode-specific fields
 	 */
 	if (!use_mode2) {
-		QMEM_WR16(qlt, req + 0x18, task->task_sense_length);
+		QMEM_WR16_REQ(qlt, qi, req + 0x18, task->task_sense_length);
 	}
-	QMEM_WR16(qlt, req + 0x1A, flags);
-	QMEM_WR32(qlt, req + 0x1C, task->task_resid);
-	QMEM_WR16(qlt, req + 0x20, cmd->cmd_oxid);
+	QMEM_WR16_REQ(qlt, qi, req + 0x1A, flags);
+	QMEM_WR32_REQ(qlt, qi, req + 0x1C, task->task_resid);
+	QMEM_WR16_REQ(qlt, qi, req + 0x20, cmd->cmd_oxid);
 	if (use_mode2) {
 		bctl = (qlt_dmem_bctl_t *)qcmd->dbuf_rsp_iu->db_port_private;
-		QMEM_WR32(qlt, req + 0x2C, 24 + task->task_sense_length);
-		QMEM_WR64(qlt, req + 0x34, bctl->bctl_dev_addr);
-		QMEM_WR32(qlt, req + 0x3C, 24 + task->task_sense_length);
+		QMEM_WR32_REQ(qlt, qi, req + 0x2C,
+		    24 + task->task_sense_length);
+		QMEM_WR64_REQ(qlt, qi, req + 0x34, bctl->bctl_dev_addr);
+		QMEM_WR32_REQ(qlt, qi, req + 0x3C,
+		    24 + task->task_sense_length);
 	} else {
-		QMEM_WR16(qlt, req + 0x22, scsi_status);
+		QMEM_WR16_REQ(qlt, qi, req + 0x22, scsi_status);
 		psd = req+0x28;
 
 		/*
@@ -3743,8 +5864,8 @@
 	/*
 	 * Trigger FW to send SCSI status out
 	 */
-	qlt_submit_req_entries(qlt, 1);
-	mutex_exit(&qlt->req_lock);
+	qlt_submit_req_entries(qlt, 1, qi);
+	mutex_exit(&qlt->mq_req[qi].mq_lock);
 
 	return (STMF_SUCCESS);
 }
@@ -3758,6 +5879,7 @@
 	qlt_dmem_bctl_t *bctl;
 	uint32_t minsize;
 	uint8_t elsop, req1f;
+	uint16_t qi = 0;
 
 	addr = els->els_resp_payload;
 	qcmd = (qlt_cmd_t *)cmd->cmd_fca_private;
@@ -3783,10 +5905,12 @@
 		req1f = (uint8_t)(req1f | BIT_4);
 	}
 
-	mutex_enter(&qlt->req_lock);
-	req = (uint8_t *)qlt_get_req_entries(qlt, 1);
+	mutex_enter(&qlt->mq_req[qi].mq_lock);
+	req = (uint8_t *)qlt_get_req_entries(qlt, 1, qi);
 	if (req == NULL) {
-		mutex_exit(&qlt->req_lock);
+		EL(qlt, "req = NULL, %xh %xh %p %xh\n", cmd->cmd_oxid,
+		    cmd->cmd_rportid, cmd, qcmd->fw_xchg_addr);
+		mutex_exit(&qlt->mq_req[qi].mq_lock);
 		qlt_dmem_free(NULL, qcmd->dbuf);
 		qcmd->dbuf = NULL;
 		return (FCT_BUSY);
@@ -3807,9 +5931,13 @@
 	QMEM_WR32(qlt, (&req[0x24]), els->els_resp_size);
 	QMEM_WR64(qlt, (&req[0x28]), bctl->bctl_dev_addr);
 	QMEM_WR32(qlt, (&req[0x30]), els->els_resp_size);
-	qlt_submit_req_entries(qlt, 1);
-	mutex_exit(&qlt->req_lock);
 
+	EL(qlt, "elsop=%xh req1f=%xh IOCB_TYPE_ELSPASS: rex1=%xh\n",
+	    elsop, req1f, qcmd->fw_xchg_addr);
+
+	qlt_submit_req_entries(qlt, 1, qi);
+	mutex_exit(&qlt->mq_req[qi].mq_lock);
+
 	return (FCT_SUCCESS);
 }
 
